<?php

/**
 This project has been generated by worker generator
 has been made by fahmi sulaiman
 sulaimanfahmi@gmail.com
 check out my github @dekaulitz
 */

namespace App\Http\Services;

use App\Http\Models\PindahsubinvModel;
use App\Http\Models\SyncUtilities\SyncHandlersModel;
use App\Http\Models\StgpelniscmmotintModel;
use App\Http\Base\BaseService;
use Illuminate\Support\Facades\DB;

class PindahsubinvService extends BaseService
{
	/**
     PindahsubinvService constructor.
	 */
	public function __construct()
	{
		parent::__construct();
		$this->model = new PindahsubinvModel();
	}

	/**
	 *  index function that get all data from database by default
	 *  @return array|static[]
	 */
	public function index()
	{
		return $this->model->getQuery()->get();
	}


	/**
	 *  this function is magic pagination injector from my library you want to add new property or field you have to inject into model in alias paging property
	 *  @param array $input
	 *  @return array
	 */
	public function paging($request)
	{
		$auth = json_decode($request->session()->get('auth'));

		$this->model->joinRelationFromLocationId()->joinRelationToLocationId()->getQuery()->select([
			"pindahsubinv.moNumber as moNumber",
			"pindahsubinv.id as id",
			"fromLocationId.namaLokasi as fromLocationName",
			"toLocationId.namaLokasi as toLocationName",
			"pindahsubinv.transactionType as transactionType",
			"pindahsubinv.dateRequired as dateRequired",
			"pindahsubinv.type as type",
			"pindahsubinv.status",
			"pindahsubinv.quantity as quantity "
		]);

		if ($auth->aplikasi != "HO") {
			$this->model->getQuery()->where("pindahsubinv.kapalId", "=", $auth->kapalId);
			// $this->model->getQuery()->where("toLocationId.kapalId", "=", $auth->kapalId); 
			// $this->model->getQuery()->where("fromLocationId.kapalId", "=", $auth->kapalId); 
		}

		$this->model->getQuery()->whereIn("pindahsubinv.fromLocationId", $auth->arrLokasi);
		// ->whereIn("pindahsubinv.toLocationId", $auth->arrLokasi);

		$this->model->getQuery()->whereIn("pindahsubinv.moNumber", function ($query) use ($auth) {
			$query->select('itempindahbarangsubinv.moNumber')
				->from('itempindahbarangsubinv')
				->join("item", function ($join) {
					$join->on("item.id", "=", "itempindahbarangsubinv.itemId");
					$join->on("item.kapalId", "=", "pindahsubinv.kapalId");
				})
				// "item.id", "=", "itempindahbarangsubinv.itemId")
				->whereIn("item.type_id", $auth->arrCategory);
		});

		$input = $request->all();
		if (!isset($input["sort"])) {
			$this->model->getQuery()->orderBy("pindahsubinv.moNumber", "desc");
		}

		$this->model->paging()->filter()->sorting();
		return $this->model->paging()->getPaging();
	}

	/**
	 *  get one raw row data from table by id
	 *  you can ad the relation like $this->model->joinSomething()->getQuery()->where("aliastable.field","=",$value)->first()
	 *  or like $this->model->joinSomething()->getQuery()->where("aliastable.field","=",$value)->select(["aliastable.fieldname"])->first(); its mean you want to join an take spesific value
	 *  and you want to take value like this $model->fieldname
	 *  @param $id
	 *  @return PindahsubinvModel
	 */
	public function show($id)
	{
		$model = $this->model->joinRelationToLocationId()->joinRelationFromLocationId()
			->joinRelationKapalId()->getQuery()
			->select([
				"pindahsubinv.*",
				"toLocationId.namaLokasi as toLocationName",
				"fromLocationId.namaLokasi as fromLocationName",
				"kapalId.namaKapal"
			])
			->where("pindahsubinv.id", "=", $id)->first();
		return $model;
	}

	public function showByTransactionNo($noTransaction)
	{
		$model = $this->model->joinRelationToLocationId()->joinRelationRequesterId()->joinRelationFromLocationId()
			->joinRelationKapalId()->getQuery()
			->select([
				"pindahsubinv.*",
				"requesterId.jabatan as requesterJabatan",
				"toLocationId.namaLokasi as toLocationName",
				"fromLocationId.namaLokasi as fromLocationName",
				"kapalId.namaKapal"
			])
			->where("pindahsubinv.moNumber", "=", $noTransaction)->first();
		return $model;
	}


	/**
	 *  this is a base function for storing data you with transaction by default
	 *  you can customization base on your business requirement as you want, you can add other object or you can to loop anc excecute the process in single process
	 *  @param array $input
	 *  @return PindahsubinvModel
	 *  @throws \Exception
	 */
	public function store($input)
	{
		$jumlahBarang = 0;
		if (isset($input["itemID"])) {
			$jumlahBarang = array_sum($input["quantity"]);
		}
		$input["approverId"] = 0;
		$input["type"] = 1;
		$input["transactionType"] = 1;
		$input["quantity"] = $jumlahBarang;

		$transactionBrg = new PindahsubinvModel();
		$transactionBrg->fill($input);
		if (!$transactionBrg->save()) {
			throw new \Exception();
		}
		return $transactionBrg->id;
	}


	/**
	 * this function will delete much data, in one action
	 * the ids is a parameter from view like 1,2,3,4 and the parameter will be exploded into single array
	 * you can remove this main alogorithm with your business requirement like soft delete or anything you want
	 *  @param $ids
	 */
	public function delete($ids)
	{
		$params = explode(".", $ids);
		$this->model->deleteBulk("id", $params);
	}


	/**
	 *  this is a base function for update and delete data by default.
	 *  you can add and custom as you want base on your requirement you can add this function as core function for handle update data from table or 
	 *  you can add multiple relation proses after update in this function 
	 *  @param $id
	 *  @param array $input 
	 *  @return PindahsubinvModel
	 *  @throws \Exception
	 */
	public function update($id, $input)
	{
		$pindahsubinv = PindahsubinvModel::find($id);
		$pindahsubinv->fill($input);
		if (!$pindahsubinv->update()) {
			throw new \Exception();
		}
		return $pindahsubinv;
	}


	/**
	 *  this function will be confirting paging property into file excel
	 *  the main library is base on excel spreadsheet library
	 *  @param array $input
	 *   @return array|static[]
	 */
	public function exportToExcel($input = array())
	{
		return $this->model->getQuery()->get();
	}

	public function getLastestID($prefix)
	{
		$getMaxID = $this->model->getQuery()->selectRaw('MAX(SUBSTRING("pindahsubinv"."moNumber", 9, 6)) AS "moNumber"')->where("pindahsubinv.moNumber", "ILIKE", $prefix . "%")->first();
		if ($getMaxID || true) {
			return $prefix . substr("000000" . ($getMaxID->moNumber + 1), -6);
		} else {
			return $prefix . "000001";
		}
	}

	public function approve($input)
	{
		$dateTimeApproved = date("Y-m-d H:i:s");
		$newInput = [
			"approverId" => $input["approverId"],
			"feedback" => $input["feedback"],
			"tglApproved" => $dateTimeApproved,
			"date_updated" => $dateTimeApproved,
			"status" => $input["status"]
		];
		$pindahsubinv = PindahsubinvModel::where("moNumber", $input["moNumber"]);
		if (!$pindahsubinv->update($newInput)) {
			throw new \Exception();
		}
		$needSync = $pindahsubinv->first();
		$sync = SyncHandlersModel::where("sync.local_id", "=", $needSync->id)
			->where("sync.table_name", "=", "pindahbarangsubinv");
		if (!$sync->update(["need_sync" => 1])) {
			throw new \Exception();
		}

		return $pindahsubinv;
	}

	public function getPrepareUpdateStock($input)
	{
		$data = [];
		if (isset($input["items"]) && !empty($input["items"])) {
			foreach ($input["items"] as $row) {
				$data[] = [
					"itemId" 		=> $row->itemId,
					"kapalId" 		=> $input["kapalId"],
					"lokasiId" 		=> $input["lokasiId"],
					"jumlah" 		=> $row->quantity,
					"satuan" 		=> "",
					"status" 		=> 1,
					"type" 			=> 1,
					"lotNumber" 	=> $row->lotNumber,
					"tglMasuk" 		=> $input["dateRequired"],
					"harga_satuan"	=> $row->harga_satuan,

					// ADDITION FOR STOCK HISTORY
					"transaksi"		=> "pindahbarangsubinv",
					"noTransaksi"	=> $input["refId"],
					"username"		=> $input["username"],
					"periode"		=> $input["dateRequired"]
				];
			}
		}
		return $data;
	}

	public function getGandroomList($request)
	{
		$model = $this->model->joinRelationToLocationId()->joinRelationFromLocationId()->getQuery()
			->select([
				"pindahsubinv.*",
				"toLocationId.namaLokasi as toLocationName",
				"fromLocationId.namaLokasi as fromLocationName"
			]);

		if ($auth->aplikasi != "HO") {
			$this->model->getQuery()->where("pindahsubinv.kapalId", "=", $auth->kapalId);
		}
		return $model;
	}

	public function saveStaging($staging)
	{
		$data = [];
		$totalLine = count($staging["footer"]);

		foreach ($staging["footer"] as $row) {
			$data[] =  [
				"transaction_number" 				=> $staging["header"]->moNumber,
				"organization_id"					=> $staging["header"]->kapalId,
				"transaction_date"					=> $staging["header"]->dateRequired, // dateCreated,
				"subinventory_code"					=> $staging["header"]->fromLocationName,
				"transfer_subinventory"				=> $staging["header"]->toLocationName,
				"transfer_date"						=> $staging["header"]->dateRequired,
				"source_code"						=> "BEGBAL",
				"process_flag"						=> 1,
				"transaction_mode"					=> 3,
				"lock_flag"							=> 2,
				"attribute14"					    => $staging["header"]->requesterJabatan,

				"inventory_item_id"					=> $row->itemId,
				"item_segment1"						=> $row->namaItem,
				"transaction_quantity"				=> $row->quantity,
				"transaction_uom"					=> $row->UOM,
				"attribute2"						=> $row->lotNumber,
				"transaction_source_type_id"		=> 13,
				"transaction_action_id"				=> 27,
				"transaction_type_id"				=> 0,

				"total_line"						=> $totalLine
			];
		}

		foreach ($data as $dat) {
			$stagingModel = new StgpelniscmmotintModel();
			$stagingModel->fill($dat);
			if (!$stagingModel->save()) {
				throw new \Exception();
			}
		}
	}
}
